/* IPAddress.h*/
#ifndef IPADDRESS__H
#define IPADDRESS__H

#include <string>
using namespace std;

/* Defines classes for virtual router */

class IPAddress {
public:
	IPAddress(unsigned int address, unsigned int maskLength);
	IPAddress(string address);
	IPAddress() {};

	~IPAddress();

	const bool operator==(const IPAddress &IP);

	unsigned int getMaskLength();
	unsigned int getAddress() { return address_;};

	 bool match(IPAddress a);  /* Does the IP address fall in this network?*/

	IPAddress net(); /* Network address only*/
	IPAddress  host(); /* Host address only (right justified) */

	string toString();
	string toStringPrefix();
	bool isBroadcast();

 private:
	unsigned int address_;
	unsigned int maskLength_;

};

#endif
